|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
java.lang.Objectcom.atlassian.jira.issue.fields.AbstractField
com.atlassian.jira.issue.fields.AbstractOrderableField
com.atlassian.jira.issue.fields.CommentSystemField
public class CommentSystemField
Defines a comment in Jira.
| Field Summary | |
|---|---|
static String |
CREATE_COMMENT
|
static String |
PARAM_COMMENT_LEVEL
The parameter name of the user-chosen group or role-type "level" for restricting the comment visibility |
static String |
PARAM_GROUP_LEVEL
The parameter name of the user-chosen group-type "level" for restricting the comment visibility |
static String |
PARAM_ROLE_LEVEL
The parameter name of the user-chosen role-type "level" for restricting the comment visibility |
| Fields inherited from interface com.atlassian.jira.issue.fields.OrderableField |
|---|
MOVE_ISSUE_PARAM_KEY, NO_HEADER_PARAM_KEY, TEMPLATE_DIRECTORY_PATH |
| Constructor Summary | |
|---|---|
CommentSystemField(com.atlassian.velocity.VelocityManager velocityManager,
ApplicationProperties applicationProperties,
JiraAuthenticationContext authenticationContext,
RendererManager rendererManager,
PermissionManager permissionManager,
CommentService commentService,
ProjectRoleManager projectRoleManager,
ProjectFactory projectFactory,
CommentSearchHandlerFactory searchHandlerFactory)
|
|
| Method Summary | |
|---|---|
String |
availableForBulkEdit(BulkEditBean bulkEditBean)
Determines whether the field is available for bulk editing given the BulkEditBean. |
boolean |
canRemoveValueFromIssueObject(Issue issue)
Returns true if a call to OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)
will actually remove the value. |
void |
createValue(Issue issue,
Object value)
Create the value of the issue in the data store. |
String |
getCreateHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
Returns the HTML that should be shown when the issue is being created. |
Object |
getDefaultValue(Issue issue)
The value that should be set on the issue if the field is not shown for some reason. |
String |
getEditHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
Returns HTML that should be shown when the issue is being edited. |
protected Object |
getRelevantParams(Map params)
Defines the object that will be passed through to the create method |
String |
getValueFromIssue(Issue issue)
Gets the value stored for this field on the provided issue. |
Object |
getValueFromParams(Map params)
Get a field value from the map of parameters passed. |
String |
getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Map displayParameters)
|
String |
getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Object value,
Map displayParameters)
|
boolean |
hasValue(Issue issue)
Determines if the field has a value for the given issue. |
boolean |
isRenderable()
Defines if a field determines itself as renderable. |
boolean |
isShown(Issue issue)
Tests field specific way to determine if it should be shown or not. |
MessagedResult |
needsMove(Collection originalIssues,
Issue targetIssue,
FieldLayoutItem targetFieldLayoutItem)
Used to determine if the field needs input from user to be moved to the new project and/or issue type. |
void |
populateAdditionalInputs(Map fieldValuesHolder,
Map additionalInputs)
Extracts comment values from the fieldValuesHolder and places them in another map to be used by the WorkflowManager. |
void |
populateDefaults(Map fieldValuesHolder,
Issue issue)
Populate the fieldValueHolder with a value that should be shown by default when the issue has not been created yet. |
void |
populateForMove(Map fieldValuesHolder,
Issue originalIssue,
Issue targetIssue)
Used to populate the fieldValueHolder with parameters for move issue screen. |
void |
populateFromIssue(Map fieldValuesHolder,
Issue issue)
Used to initialise the fieldValuesHolder from the current value of teh issue. |
void |
populateParamsFromString(Map fieldValuesHolder,
String stringValue,
Issue issue)
Used to convert from a user friendly string value and put the result into the fieldValuesHolder. |
void |
removeValueFromIssueObject(MutableIssue issue)
Removes the field value from the given MutableIssue object. |
void |
updateIssue(FieldLayoutItem fieldLayoutItem,
MutableIssue issue,
Map fieldValueHolder)
Sets the value as a modified external field in the issue so that this field will be updated along with all the other modified issue values. |
void |
updateValue(FieldLayoutItem fieldLayoutItem,
Issue issue,
ModifiedValue modifiedValue,
IssueChangeHolder issueChangeHolder)
Update the issue in the data store. |
void |
validateParams(OperationContext operationContext,
ErrorCollection errorCollectionToAddTo,
I18nHelper i18n,
Issue issue,
FieldScreenRenderLayoutItem fieldScreenRenderLayoutItem)
Ensure that the parameters are valid |
| Methods inherited from class com.atlassian.jira.issue.fields.AbstractOrderableField |
|---|
createAssociatedSearchHandler, getApplicationProperties, getBulkEditHtml, getCreateHtml, getEditHtml, getPermissionManager, getVelocityParams, getVelocityParams, getViewHtml, hasBulkUpdatePermission, hasPermission, isHidden, populateFromParams, rendererTypesEqual, renderTemplate, valuesEqual |
| Methods inherited from class com.atlassian.jira.issue.fields.AbstractField |
|---|
compareTo, equals, getAuthenticationContext, getId, getName, getNameKey, hashCode |
| Methods inherited from class java.lang.Object |
|---|
clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait |
| Methods inherited from interface com.atlassian.jira.issue.fields.renderer.RenderableField |
|---|
getId |
| Methods inherited from interface com.atlassian.jira.issue.fields.Field |
|---|
getId, getName, getNameKey |
| Methods inherited from interface java.lang.Comparable |
|---|
compareTo |
| Field Detail |
|---|
public static final String CREATE_COMMENT
public static final String PARAM_GROUP_LEVEL
public static final String PARAM_COMMENT_LEVEL
public static final String PARAM_ROLE_LEVEL
| Constructor Detail |
|---|
public CommentSystemField(com.atlassian.velocity.VelocityManager velocityManager,
ApplicationProperties applicationProperties,
JiraAuthenticationContext authenticationContext,
RendererManager rendererManager,
PermissionManager permissionManager,
CommentService commentService,
ProjectRoleManager projectRoleManager,
ProjectFactory projectFactory,
CommentSearchHandlerFactory searchHandlerFactory)
| Method Detail |
|---|
protected Object getRelevantParams(Map params)
getRelevantParams in class AbstractOrderableFieldparams - is a representation of the request params that are available
public String getCreateHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
OrderableField
getCreateHtml in interface OrderableFieldfieldLayoutItem - FieldLayoutItemoperationContext - OperationContextaction - Actionissue - IssuedisplayParameters - Map of display parameters.
public String getEditHtml(FieldLayoutItem fieldLayoutItem,
OperationContext operationContext,
webwork.action.Action action,
Issue issue,
Map displayParameters)
OrderableField
getEditHtml in interface OrderableFieldfieldLayoutItem - FieldLayoutItemoperationContext - OperationContextaction - Actionissue - IssuedisplayParameters - Map of display parameters.
public String getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Map displayParameters)
getViewHtml in interface OrderableField
public String getViewHtml(FieldLayoutItem fieldLayoutItem,
webwork.action.Action action,
Issue issue,
Object value,
Map displayParameters)
getViewHtml in interface OrderableFieldpublic boolean isShown(Issue issue)
OrderableField
isShown in interface OrderableFieldissue - The Issue.
public void populateDefaults(Map fieldValuesHolder,
Issue issue)
OrderableField
populateDefaults in interface OrderableFieldfieldValuesHolder - The fieldValuesHolder Map to be populated.issue - The Issue.
public void populateAdditionalInputs(Map fieldValuesHolder,
Map additionalInputs)
fieldValuesHolder - a map containing comment values from a BulkEdit. Obtained from BulkEditBean.additionalInputs - a map to be passed onto a WorkflowManager.
public void populateFromIssue(Map fieldValuesHolder,
Issue issue)
OrderableField
populateFromIssue in interface OrderableFieldfieldValuesHolder - The fieldValuesHolder Map to be populated.issue - The Issue.
public void validateParams(OperationContext operationContext,
ErrorCollection errorCollectionToAddTo,
I18nHelper i18n,
Issue issue,
FieldScreenRenderLayoutItem fieldScreenRenderLayoutItem)
OrderableField
validateParams in interface OrderableFieldoperationContext - OperationContexterrorCollectionToAddTo - ErrorCollection to add to.i18n - I18nHelperissue - This is passed to get the value of other fields that may or may not have been modified.fieldScreenRenderLayoutItem - FieldScreenRenderLayoutItempublic Object getDefaultValue(Issue issue)
OrderableFieldFor example: The user does not have permission to see the field, or the field is not part of the create screen.
getDefaultValue in interface OrderableFieldissue - the Issue.
public void createValue(Issue issue,
Object value)
OrderableField
createValue in interface OrderableFieldissue - Issue this field is part ofvalue - Value to store in this field (eg. Collection for Version fields). Cannot be null.
public void updateValue(FieldLayoutItem fieldLayoutItem,
Issue issue,
ModifiedValue modifiedValue,
IssueChangeHolder issueChangeHolder)
OrderableFieldFields that are simply stored in the JIRAISSUE DB table, need not do anything here as this table is written to one time to include all fields that changed. Fields using other DB tables must update that table with the appropriate values.
updateValue in interface OrderableFieldfieldLayoutItem - for this field within this contextissue - Issue this field is part ofmodifiedValue - new value to set field to. Cannot be null.issueChangeHolder - an object to record any changes made to the issue by this method.
public void updateIssue(FieldLayoutItem fieldLayoutItem,
MutableIssue issue,
Map fieldValueHolder)
updateIssue in interface OrderableFieldfieldLayoutItem - FieldLayoutItemissue - MutableIssuefieldValueHolder - Field Value Holder MapOrderableField.updateValue(com.atlassian.jira.issue.fields.layout.field.FieldLayoutItem, com.atlassian.jira.issue.Issue, com.atlassian.jira.issue.ModifiedValue, com.atlassian.jira.issue.util.IssueChangeHolder)
public MessagedResult needsMove(Collection originalIssues,
Issue targetIssue,
FieldLayoutItem targetFieldLayoutItem)
OrderableField
needsMove in interface OrderableFieldoriginalIssues - Collection of original Issues.targetIssue - Target Issue.targetFieldLayoutItem - FieldLayoutItem
public void populateForMove(Map fieldValuesHolder,
Issue originalIssue,
Issue targetIssue)
OrderableFieldOrderableField.needsMove(java.util.Collection,com.atlassian.jira.issue.Issue,com.atlassian.jira.issue.fields.layout.field.FieldLayoutItem)
returned true, and the remote user (the one performing the move) has the permission to actually update this field.
populateForMove in interface OrderableFieldfieldValuesHolder - Map of field Values.originalIssue - orignal IssuetargetIssue - target Issuepublic void removeValueFromIssueObject(MutableIssue issue)
OrderableFieldNote that this operation does not actually persist the change, it just clears the value from the given Issue object. The caller will still need to call #updateValue() in order to persist the change.
Some Fields may choose to quietly ignore this request. eg The SecurityLevel Field will not remove Security Level from subtasks because the subtask must always take the Security Level of its parent issue.
removeValueFromIssueObject in interface OrderableFieldissue - The issue object to be effected.OrderableField.canRemoveValueFromIssueObject(com.atlassian.jira.issue.Issue),
OrderableField.updateValue(com.atlassian.jira.issue.fields.layout.field.FieldLayoutItem, com.atlassian.jira.issue.Issue, com.atlassian.jira.issue.ModifiedValue, com.atlassian.jira.issue.util.IssueChangeHolder)public boolean canRemoveValueFromIssueObject(Issue issue)
OrderableFieldtrue if a call to OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)
will actually remove the value.
There a few different reasons why this method may return false:
canRemoveValueFromIssueObject in interface OrderableFieldissue - The Issue object.
true if a call to OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)
will actually remove the value.OrderableField.removeValueFromIssueObject(com.atlassian.jira.issue.MutableIssue)public boolean hasValue(Issue issue)
OrderableField
hasValue in interface OrderableFieldissue - the Issue.
public Object getValueFromParams(Map params)
throws FieldValidationException
OrderableField
getValueFromParams in interface OrderableFieldparams - the map of parameters.
FieldValidationException - if there is a problem with Field Validation.
public void populateParamsFromString(Map fieldValuesHolder,
String stringValue,
Issue issue)
throws FieldValidationException
OrderableField
populateParamsFromString in interface OrderableFieldfieldValuesHolder - Map of field Values.stringValue - user friendly string valueissue - the Issue
FieldValidationException - if cannot convert to a value from the given stringpublic String getValueFromIssue(Issue issue)
RenderableField
getValueFromIssue in interface RenderableFieldissue - identifies the issue that will contain the value for this field.
public boolean isRenderable()
RenderableField
isRenderable in interface RenderableFieldpublic String availableForBulkEdit(BulkEditBean bulkEditBean)
OrderableField
availableForBulkEdit in interface OrderableFieldbulkEditBean - holds the state of the bulk-edit wizard (e.g. the selected issues for bulk editing)
null if the field is available for bulk-editing or an i18n key of the error message to show as
why the field is not available.
|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||